import { Player, world, system, Vector} from "@minecraft/server";

world.afterEvents.playerInteractWithEntity.subscribe((eventData) => {
    try {
        const player = eventData.player;
        const itemInHand = eventData.itemStack;

        // Check if the player right clicks and holds a bowl
        if (itemInHand && itemInHand.typeId === "minecraft:bowl") {
            // Get the variant of the frog
            const targetEntity = eventData.target;

            // Check if targetEntity exists before accessing its components
            if (targetEntity) {
                try {
                    const variantComponent = targetEntity.getComponent("minecraft:variant");

                    // Check if variantComponent is not undefined before accessing its value
                    if (variantComponent) {
                        const variant = variantComponent.value;

                        // Your logic based on the variant goes here
                        switch (variant) {
                            case 0:
                               
targetEntity.remove()
if (itemInHand.amount > 1) {
            player.runCommand("give @s frogbowls:bowl_frog_temperate")
            player.runCommand("clear @s[m=!c] bowl 0 1")
        } else {
            player.runCommand("replaceitem entity @s slot.weapon.mainhand 0 frogbowls:bowl_frog_temperate 1 0")
        }
player.runCommand("playsound mob.frog.ambient @a[r=8] ~~~ 1 1 1");
player.runCommand("playsound break.decorated_pot @a ~~~");

                                break;
                            case 1:
targetEntity.remove()
if (itemInHand.amount > 1) {
            player.runCommand("give @s frogbowls:bowl_frog_cold")
            player.runCommand("clear @s[m=!c] bowl 0 1")
        } else {
            player.runCommand("replaceitem entity @s slot.weapon.mainhand 0 frogbowls:bowl_frog_cold 1 0")
        }
player.runCommand("playsound mob.frog.ambient @a[r=8] ~~~ 1 1 1");
player.runCommand("playsound break.decorated_pot @a ~~~");
                                break;
                            case 2:
targetEntity.remove();
if (itemInHand.amount > 1) {
            player.runCommand("give @s frogbowls:bowl_frog_warm")
            player.runCommand("clear @s[m=!c] bowl 0 1")
        } else {
            player.runCommand("replaceitem entity @s slot.weapon.mainhand 0 frogbowls:bowl_frog_warm 1 0")
        }
player.runCommand("playsound mob.frog.ambient @a[r=8] ~~~ 1 1 1");
player.runCommand("playsound break.decorated_pot @a ~~~");
                                break;
                            default:
                                player.sendMessage("Unknown frog variant!");
                        }
                    } else {
                        console.warn("No variantComponent found for the target entity.");
                    }
                } catch (error) {
                    console.warn("Error accessing frog variant: ", error);
                }
            } else {
                console.warn("No target entity found during player interaction.");
            }
        }
    } catch (error) {
        console.warn("Error during player interaction with entity: ", error);
    }
});


world.afterEvents.playerInteractWithBlock.subscribe((event) => {
    let { block, blockFace, itemStack, player } = event;
const filters = ['minecraft:barrel', 'minecraft:chest', 'minecraft:crafting_table', 'minecraft:enchant_table', 'minecraft:anvil', 'minecraft:trapped_chest', 'minecraft:hopper', 'minecraft:wooden_door','minecraft:wooden_trapdoor','minecraft:acacia_door','minecraft:acacia_trapdoor','minecraft:iron_door','minecraft:iron_trapdoor','minecraft:bamboo_door','minecraft:bamboo_trapdoor','minecraft:birch_door','minecraft:birch_trapdoor','minecraft:cherry_door','minecraft:cherry_trapdoor','minecraft:crimson_trapdoor','minecraft:crimson_door','minecraft:dark_oak_door','minecraft:dark_oak_trapdoor','minecraft:jungle_door','minecraft:trapdoor','minecraft:jungle_trapdoor','minecraft:mangrove_trapdoor','minecraft:mangrove_door','minecraft:spruce_trapdoor','minecraft:spruce_door','minecraft:dispenser', 'minecraft:command_block','minecraft:repeating_command_block', 'minecraft:comparator', 'minecraft:repeater', 'minecraft:decorated_pot', 'minecraft:chain_command_block','minecraft:item_frame','minecraft:switch','minecraft:smithing_table', 'minecraft:glow_frame', 'minecraft:cartography_table', 'minecraft:crafting_table','minecraft:frame', 'minecraft:dropper','minecraft:furnace','minecraft:smoker','minecraft:blast_furnace']
if (!filters.includes(block.typeId)) {
    if (!itemStack?.typeId.startsWith("frogbowls:bowl_frog_warm")) return;
    if ((player['spawnCD'] ?? 0) > Date.now()) return;
    const name = itemStack.nameTag ?? "";
    const type = "warm"; itemStack.typeId.split("frogbowls:bowl_frog_warm")[1]
    switch (blockFace) {
        case "Down": block = block.below(); break;
        case "Up": block = block.above(); break;
        case "East": block = block.east(); break;
        case "North": block = block.north(); break;
        case "South": block = block.south(); break;
        case "West": block = block.west(); break;
    }
        player['spawnCD'] = Date.now() + 500; // 1 second delay
        const entity = player.dimension.spawnEntity('minecraft:frog', block.center());
        entity.nameTag = name;
        entity.triggerEvent(`spawn_${type}`);
        player.runCommandAsync("replaceitem entity @s slot.weapon.mainhand 0 bowl");
        player.runCommandAsync("playsound mob.frog.ambient @a ~~~");
player.runCommandAsync("playsound break.decorated_pot @a ~~~");
    }
});

world.afterEvents.playerInteractWithBlock.subscribe((event) => {
    let { block, blockFace, itemStack, player } = event;
const filters = ['minecraft:barrel', 'minecraft:chest', 'minecraft:crafting_table', 'minecraft:enchant_table', 'minecraft:anvil', 'minecraft:trapped_chest', 'minecraft:hopper', 'minecraft:wooden_door','minecraft:wooden_trapdoor','minecraft:acacia_door','minecraft:acacia_trapdoor','minecraft:iron_door','minecraft:iron_trapdoor','minecraft:bamboo_door','minecraft:bamboo_trapdoor','minecraft:birch_door','minecraft:birch_trapdoor','minecraft:cherry_door','minecraft:cherry_trapdoor','minecraft:crimson_trapdoor','minecraft:crimson_door','minecraft:dark_oak_door','minecraft:dark_oak_trapdoor','minecraft:jungle_door','minecraft:trapdoor','minecraft:jungle_trapdoor','minecraft:mangrove_trapdoor','minecraft:mangrove_door','minecraft:spruce_trapdoor','minecraft:spruce_door','minecraft:dispenser', 'minecraft:command_block','minecraft:repeating_command_block', 'minecraft:comparator', 'minecraft:repeater', 'minecraft:decorated_pot', 'minecraft:chain_command_block','minecraft:item_frame','minecraft:switch','minecraft:smithing_table', 'minecraft:glow_frame', 'minecraft:cartography_table', 'minecraft:crafting_table','minecraft:frame', 'minecraft:dropper','minecraft:furnace','minecraft:smoker','minecraft:blast_furnace']
if (!filters.includes(block.typeId)) {
    if (!itemStack?.typeId.startsWith("frogbowls:bowl_frog_temperate")) return;
    if ((player['spawnCD'] ?? 0) > Date.now()) return;
    const name = itemStack.nameTag ?? "";
    const type = "temperate"; itemStack.typeId.split("frogbowls:bowl_frog_temperate")[1]
    switch (blockFace) {
        case "Down": block = block.below(); break;
        case "Up": block = block.above(); break;
        case "East": block = block.east(); break;
        case "North": block = block.north(); break;
        case "South": block = block.south(); break;
        case "West": block = block.west(); break;
    }
        player['spawnCD'] = Date.now() + 500; // 1 second delay
        const entity = player.dimension.spawnEntity('minecraft:frog', block.center());
        entity.nameTag = name;
        entity.triggerEvent(`spawn_${type}`);
        player.runCommandAsync("replaceitem entity @s slot.weapon.mainhand 0 bowl");
        player.runCommandAsync("playsound mob.frog.ambient @a ~~~");
player.runCommandAsync("playsound break.decorated_pot @a ~~~");
    }
});


world.afterEvents.playerInteractWithBlock.subscribe((event) => {
    let { block, blockFace, itemStack, player } = event;
const filters = ['minecraft:barrel', 'minecraft:chest', 'minecraft:crafting_table', 'minecraft:enchant_table', 'minecraft:anvil', 'minecraft:trapped_chest', 'minecraft:hopper', 'minecraft:wooden_door','minecraft:wooden_trapdoor','minecraft:acacia_door','minecraft:acacia_trapdoor','minecraft:iron_door','minecraft:iron_trapdoor','minecraft:bamboo_door','minecraft:bamboo_trapdoor','minecraft:birch_door','minecraft:birch_trapdoor','minecraft:cherry_door','minecraft:cherry_trapdoor','minecraft:crimson_trapdoor','minecraft:crimson_door','minecraft:dark_oak_door','minecraft:dark_oak_trapdoor','minecraft:jungle_door','minecraft:trapdoor','minecraft:jungle_trapdoor','minecraft:mangrove_trapdoor','minecraft:mangrove_door','minecraft:spruce_trapdoor','minecraft:spruce_door','minecraft:dispenser', 'minecraft:command_block','minecraft:repeating_command_block', 'minecraft:comparator', 'minecraft:repeater', 'minecraft:decorated_pot', 'minecraft:chain_command_block','minecraft:item_frame','minecraft:switch','minecraft:smithing_table', 'minecraft:glow_frame', 'minecraft:cartography_table', 'minecraft:crafting_table','minecraft:frame', 'minecraft:dropper','minecraft:furnace','minecraft:smoker','minecraft:blast_furnace']
if (!filters.includes(block.typeId)) {
    if (!itemStack?.typeId.startsWith("frogbowls:bowl_frog_cold")) return;
    if ((player['spawnCD'] ?? 0) > Date.now()) return;
    const name = itemStack.nameTag ?? "";
    const type = "cold"; itemStack.typeId.split("frogbowls:bowl_frog_cold")[1]
    switch (blockFace) {
        case "Down": block = block.below(); break;
        case "Up": block = block.above(); break;
        case "East": block = block.east(); break;
        case "North": block = block.north(); break;
        case "South": block = block.south(); break;
        case "West": block = block.west(); break;
    }
        player['spawnCD'] = Date.now() + 500; // 1 second delay
        const entity = player.dimension.spawnEntity('minecraft:frog', block.center());
        entity.nameTag = name;
        entity.triggerEvent(`spawn_${type}`);
        player.runCommandAsync("replaceitem entity @s slot.weapon.mainhand 0 bowl");
        player.runCommandAsync("playsound mob.frog.ambient @a ~~~");
player.runCommandAsync("playsound break.decorated_pot @a ~~~");
    }
});
